#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gdevlib.h"
#include "screen.h"
#include "tsp.h"
#define         isgn(x) ((x>0)-(x<0))
#define         iabs(x) ((x)>0 ? (x):-(x))

#define MAX_SP    256
#define MAX_PCG    32
#define SP_SIZE    32

int main()
{
int i,j ;
int sx,sy ;
struct TSP_WINDOW *tsp_win ;
struct TSP_PIX    *pcg_pat ;
struct TSP_PIX     clr_pix ;
struct TSP_SP     *sp      ;
 
 clr_pix.a=0 ; clr_pix.r=0 ; clr_pix.g=0 ; clr_pix.b=0 ;
 pcg_pat=malloc(sizeof(struct TSP_PIX)*SP_SIZE*SP_SIZE) ;
 if( pcg_pat==NULL ) exit(-1) ;
 sp=malloc( sizeof(struct TSP_SP) * MAX_SP ) ;
 if( sp==NULL ) exit(-1) ;
 tsp_win=init_window() ;
 if( tsp_win==NULL ) exit(-1) ;
 if( init_pcg(MAX_PCG)!=0 ) exit(-1) ;
 for( i=0 ; i<MAX_PCG ; i++ ){
   for( j=0 ; j<(SP_SIZE*SP_SIZE) ; j++ ){
     pcg_pat[j].a=255 ;
     pcg_pat[j].r=255/32*i ;
     pcg_pat[j].g=255/32*i ;
     pcg_pat[j].b=255/32*i ;
   }
   add_pcg( pcg_pat, TSP_32 ) ;
 }
 if( init_sp(MAX_SP) !=0 ) exit(-1) ;

 for( i=0 ; i<MAX_SP ; i++ ){
   sp[i].x  =rand()%256  ;
   sp[i].y  =rand()%256  ;
   sp[i].vx =rand()%8+1  ;
   sp[i].vy =rand()%8+1  ;
   sp[i].pcg=rand()%32+1 ;
 }
 for( j=0 ; j<32000 ; j++ ){
   for( i=0 ; i<MAX_SP ; i++ ){
     sp[i].x+=sp[i].vx ;
     sp[i].y+=sp[i].vy ;
     if( sp[i].x<0 ){ sp[i].x=0 ; sp[i].vx=-sp[i].vx ;}
     if( sp[i].y<0 ){ sp[i].y=0 ; sp[i].vy=-sp[i].vy ;}
     if( sp[i].x>=tsp_win->width  ){
       sp[i].x =tsp_win->width -1 ;
       sp[i].vx =(rand()%8+1) * -(isgn(sp[i].vx)) ;
     }
     if( sp[i].y>=tsp_win->height ){
       sp[i].y =tsp_win->height-1 ;
       sp[i].vy =(rand()%8+1) * -(isgn(sp[i].vy)) ;
     }
     set_sp( &sp[i] ) ;
   }
   
   for( sy=0 ; sy<tsp_win->height ; sy++ ){
     struct TSP_PIX  *tmpp=gd->vram ;
     clr_pix.g=j%256 ;
     clr_pix.b=j%256 ;
     for( sx=0 ; sx<tsp_win->width ; sx++ ){
       tmpp[sx+sy*tsp_win->real_width]=clr_pix ;
       clr_pix.g=(clr_pix.g+1)%256 ;
       clr_pix.b=(clr_pix.b+1)%256 ;
     }
   }
   
   if( draw_sp( tsp_win )!=0 ) break ;
 }
 exit(0) ;
}
